package com.hgwebservice.dal.dataobject.data;

import com.baomidou.mybatisplus.annotation.KeySequence;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import lombok.*;

import java.util.Date;

/**
 * 待执行医嘱 DO
 *
 * @author super_admin
 */
@TableName("dispatch_info")
@KeySequence("dispatch_info_seq") // 用于 Oracle、PostgreSQL、Kingbase、DB2、H2 数据库的主键自增。如果是 MySQL 等数据库，可不写。
@Data
@ToString(callSuper = true)
@Builder
@NoArgsConstructor
@AllArgsConstructor
public class DispatchInfoDO {

    /**
     * 主键自增
     */
    @TableId
    private Integer id;
    /**
     * 医嘱编号
     */
    private String code;
    /**
     * 医嘱类型
     */
    private Integer type;
    /**
     * 医嘱详细内容
     */
    private String message;
    /**
     * 频率
     */
    private String frequency;
    /**
     * 所属科室
     */
    private String departCode;
    /**
     * 病人唯一码 
     */
    private String patientCode;
    /**
     * 住院号
     */
    private String admCode;
    /**
     *  血糖或胰岛素医嘱(1,	血糖医嘱; 2, 胰岛素	医嘱)
     */
    private String dispatchType;

    private Date createTime;

    private Date updateTime;
    /**
     * 医院code
     */
    private String hospitalCode;
    /**
     * 医院id
     */
    private Integer hospitalId;

}
