package com.hgwebservice.dal.dataobject.data;

import lombok.*;
import java.util.*;
import com.baomidou.mybatisplus.annotation.*;

/**
 * 住院患者信息 DO
 *
 * @author super_admin
 */
@TableName("patient_data")
@KeySequence("patient_data_seq") // 用于 Oracle、PostgreSQL、Kingbase、DB2、H2 数据库的主键自增。如果是 MySQL 等数据库，可不写。
@Data
@ToString(callSuper = true)
@Builder
@NoArgsConstructor
@AllArgsConstructor
public class PatientDataDO {

    /**
     * 主键id
     */
    @TableId
    private Integer id;
    /**
     * 必填 (每个病人的唯一标记，不可重复)
     */
    private String patientNo;
    /**
     * 住院号
     */
    private String hospitalNo;
    /**
     * 腕带号
     */
    private String wristbandNo;
    /**
     * 住院次数
     */
    private Integer hospitalCount;
    /**
     * 姓名
     */
    private String name;
    /**
     * 性别
     */
    private String gender;
    /**
     * 出生日期
     */
    private String birthday;
    /**
     * 年龄
     */
    private Integer age;
    /**
     * 身份证号
     */
    private String identifyNo;
    /**
     * 床号
     */
    private String bedNo;
    /**
     * 病区代码
     */
    private String wardCode;
    /**
     * 病区名称
     */
    private String wardName;
    /**
     * 科室代码
     */
    private String deptCode;
    /**
     * 科室名称
     */
    private String deptName;
    /**
     * 管床医生姓名
     */
    private String doctorName;
    /**
     * 入院日期
     */
    private Date hospitalDate;

    private Date createTime;

    private Date updateTime;
    /**
     * 医疗机构代码
     */
    private String hospitalCode;
    /**
     * 医院id
     */
    private Integer hospitalId;

}
