package com.hgwebservice.service.syncCdm2;

import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.collection.CollUtil;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.hgwebservice.dal.dataobject.data.DispatchDataDO;
import com.hgwebservice.dal.dataobject.data.DispatchInfoDO;
import com.hgwebservice.dal.dataobject.data.OperatorDataDO;
import com.hgwebservice.dal.dataobject.data.PatientDataDO;
import com.hgwebservice.dal.mysql.data.DispatchDataMapper;
import com.hgwebservice.dal.mysql.data.DispatchInfoMapper;
import com.hgwebservice.dal.mysql.data.OperatorDataMapper;
import com.hgwebservice.dal.mysql.data.PatientDataMapper;
import com.hgwebservice.entity.hisview.DispatchData;
import com.hgwebservice.util.WebServiceUtil;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.List;
import java.util.Optional;
import java.util.stream.Collectors;

@Service
public class SyncDispatchDataByDeptCodeImpl implements SyncDispatchDataByDeptCode {
    @Autowired
    OperatorDataMapper operatorDataMapper;
    @Autowired
    DispatchDataMapper dispatchDataMapper;
    @Autowired
    DispatchInfoMapper dispatchInfoMapper;
    @Autowired
    PatientDataMapper patientDataMapper;
    @Autowired
    SyncDispatchInfoByDeptCode syncDispatchInfoByDeptCode;
    @Value("${hospital_id}")
    private Integer hospitalId;
    @Override
    public void saveCdm2() {
        LambdaQueryWrapper<DispatchDataDO> dispatchDataDOLambdaQueryWrapper = new LambdaQueryWrapper<>();
        dispatchDataDOLambdaQueryWrapper.eq(DispatchDataDO::getHospitalId,hospitalId);
        List<DispatchDataDO> dispatchDataDOS1 = dispatchDataMapper.selectList(dispatchDataDOLambdaQueryWrapper);
        LambdaQueryWrapper<DispatchInfoDO> dispatchInfoDOLambdaQueryWrapper = new LambdaQueryWrapper<>();
        dispatchInfoDOLambdaQueryWrapper.eq(DispatchInfoDO::getHospitalId,hospitalId);
        List<DispatchInfoDO> dispatchInfoDOList = dispatchInfoMapper.selectList(dispatchInfoDOLambdaQueryWrapper);
        LambdaQueryWrapper<PatientDataDO> patientDataDOLambdaQueryWrapper = new LambdaQueryWrapper<>();
        patientDataDOLambdaQueryWrapper.eq(PatientDataDO::getHospitalId,hospitalId);
        List<PatientDataDO> patientDataDOS = patientDataMapper.selectList(patientDataDOLambdaQueryWrapper);
        if (CollUtil.isNotEmpty(patientDataDOS)) {
                for (PatientDataDO patientDataDO : patientDataDOS) {
                    List<DispatchData> dispatchData = WebServiceUtil.getDispatchDataByDeptCode(patientDataDO.getPatientNo(),patientDataDO.getDeptCode());
                    if (CollUtil.isNotEmpty(dispatchData)){
                        for (DispatchData dispatchDatum : dispatchData) {
                            if (dispatchDatum.getPatientNo()!=null){
                                Optional<PatientDataDO> first = patientDataDOS.stream().filter(item -> item.getPatientNo().equals(dispatchDatum.getPatientNo())).findFirst();
                                if (first.isPresent()){
                                    dispatchDatum.setHospitalNo(first.get().getHospitalNo());
                                }
                            }
                        }
                        List<Integer> deletedIds=new ArrayList<>();
                        List<String> updateIds=new ArrayList<>();
                        List<DispatchDataDO> collect1 = dispatchDataDOS1.stream().filter(item -> item.getPatientNo().equals(patientDataDO.getPatientNo())).collect(Collectors.toList());
                        for (DispatchDataDO dispatchDataDO : collect1) {
                            Optional<DispatchData> first = dispatchData.stream().filter(item -> item.getDispatchNo().equals(dispatchDataDO.getDispatchNo())).findFirst();
                            if (!first.isPresent()){
                                deletedIds.add(dispatchDataDO.getId());
                            }else{
                                // 如果存在则不用新增
                                updateIds.add(dispatchDataDO.getDispatchNo());
                            }
                        }
                        if (CollUtil.isNotEmpty(deletedIds)){
                            dispatchDataMapper.deleteBatchIds(deletedIds);
                        }
                        List<DispatchData> insertDispatchData;
                        if (CollUtil.isNotEmpty(updateIds)){
                            insertDispatchData=dispatchData.stream().filter(item->!updateIds.contains(item.getDispatchNo())).collect(Collectors.toList());
                        }else{
                            insertDispatchData=dispatchData;
                        }
                        if (CollUtil.isNotEmpty(insertDispatchData)){
                            List<DispatchDataDO> dispatchDataDOS = BeanUtil.copyToList(insertDispatchData, DispatchDataDO.class);
                            operatorDataMapper.insertDispatchData(dispatchDataDOS,hospitalId);
                        }

                    }
                    if (dispatchData!=null && dispatchData.size()==0){
                        List<Integer> ids = dispatchDataDOS1.stream().filter(item -> item.getPatientNo().equals(patientDataDO.getPatientNo())).map(DispatchDataDO::getId).collect(Collectors.toList());
                        if (CollUtil.isNotEmpty(ids)){
                            dispatchDataMapper.deleteBatchIds(ids);
                        }
                    }

                    // 更新到dispatch_info表
                    syncDispatchInfoByDeptCode.saveCdm2(dispatchData,patientDataDO.getPatientNo(),dispatchInfoDOList);
                }
        }
    }
}
