package com.hgwebservice.service.syncCdm2;

import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.collection.CollUtil;
import cn.hutool.core.util.StrUtil;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.hgwebservice.dal.dataobject.data.DispatchInfoDO;
import com.hgwebservice.dal.dataobject.data.OperatorDataDO;
import com.hgwebservice.dal.mysql.data.DispatchInfoMapper;
import com.hgwebservice.dal.mysql.data.OperatorDataMapper;
import com.hgwebservice.entity.hisview.DispatchData;
import com.hgwebservice.util.DeptEnum;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.List;
import java.util.Optional;
import java.util.stream.Collectors;

@Service
public class SyncDispatchInfoByDeptCodeImpl implements SyncDispatchInfoByDeptCode {
    @Autowired
    OperatorDataMapper operatorDataMapper;
    @Autowired
    DispatchInfoMapper dispatchInfoMapper;
    @Value("${hospital_id}")
    private Integer hospitalId;
    @Override
    public void saveCdm2(List<DispatchData> dispatchDataParam,String patientNo,List<DispatchInfoDO> dispatchInfoDOS) {
                    if (CollUtil.isNotEmpty(dispatchDataParam)){
                        List<DispatchInfoDO> dispatchData = dispatchDataParam.stream().map(item -> {
                            DispatchInfoDO dispatchInfoDO = new DispatchInfoDO();
                            dispatchInfoDO.setCode(item.getDispatchNo());
                            if (StrUtil.isNotEmpty(item.getType())){
                                if (item.getType().equals("临时")){
                                    dispatchInfoDO.setType(0);
                                }else{
                                    dispatchInfoDO.setType(1);
                                }
                            }else{
                                dispatchInfoDO.setType(2);
                            }
                            dispatchInfoDO.setMessage(item.getMessage());
                            dispatchInfoDO.setFrequency(item.getFrequency());
                            dispatchInfoDO.setDepartCode(item.getDeptCode());
                            dispatchInfoDO.setPatientCode(item.getPatientNo());
                            dispatchInfoDO.setAdmCode(item.getHospitalNo());
                            dispatchInfoDO.setDispatchType(item.getDispatchType());
                            dispatchInfoDO.setHospitalId(hospitalId);
                            return dispatchInfoDO;
                        }).collect(Collectors.toList());
                        List<Integer> deletedIds=new ArrayList<>();
                        List<String> updateIds=new ArrayList<>();
                        List<DispatchInfoDO> collect1 = dispatchInfoDOS.stream().filter(item -> item.getPatientCode().equals(patientNo)).collect(Collectors.toList());
                        for (DispatchInfoDO dispatchDataDO : collect1) {
                            Optional<DispatchInfoDO> first = dispatchData.stream().filter(item -> item.getCode().equals(dispatchDataDO.getCode())).findFirst();
                            if (!first.isPresent()){
                                deletedIds.add(dispatchDataDO.getId());
                            }else{
                                // 如果存在则不用新增
                                updateIds.add(dispatchDataDO.getCode());
                            }
                        }
                        if (CollUtil.isNotEmpty(deletedIds)){
                            dispatchInfoMapper.deleteBatchIds(deletedIds);
                        }
                        List<DispatchInfoDO> insertDispatchInfo;
                        if (CollUtil.isNotEmpty(updateIds)){
                            insertDispatchInfo=dispatchData.stream().filter(item->!updateIds.contains(item.getCode())).collect(Collectors.toList());
                        }else{
                            insertDispatchInfo=dispatchData;
                        }
                        if (CollUtil.isNotEmpty(updateIds)){
                            List<DispatchInfoDO> collect = dispatchData.stream().filter(item -> updateIds.contains(item.getCode())).collect(Collectors.toList());
                            operatorDataMapper.updateDispatchInfo(collect);
                        }
                        if (CollUtil.isNotEmpty(insertDispatchInfo)){
                            List<DispatchInfoDO> dispatchDataDOS = BeanUtil.copyToList(insertDispatchInfo, DispatchInfoDO.class);
                            operatorDataMapper.insertDispatchInfo(dispatchDataDOS,hospitalId);
                        }
                    }

                    if (dispatchDataParam!=null && dispatchDataParam.size()==0){
                        List<Integer> ids = dispatchInfoDOS.stream().filter(item -> item.getPatientCode().equals(patientNo)).map(DispatchInfoDO::getId).collect(Collectors.toList());
                        if (CollUtil.isNotEmpty(ids)){
                            dispatchInfoMapper.deleteBatchIds(ids);
                        }
                    }
    }
}
