package com.hgwebservice.service.syncCdm2;

import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.collection.CollUtil;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.hgwebservice.dal.dataobject.data.DispatchDataDO;
import com.hgwebservice.dal.dataobject.data.DispatchInfoDO;
import com.hgwebservice.dal.dataobject.data.OperatorDataDO;
import com.hgwebservice.dal.dataobject.data.PatientDataDO;
import com.hgwebservice.dal.mysql.data.DispatchDataMapper;
import com.hgwebservice.dal.mysql.data.DispatchInfoMapper;
import com.hgwebservice.dal.mysql.data.OperatorDataMapper;
import com.hgwebservice.dal.mysql.data.PatientDataMapper;
import com.hgwebservice.entity.hisview.OperatorData;
import com.hgwebservice.entity.hisview.PatientData;
import com.hgwebservice.util.DeptEnum;
import com.hgwebservice.util.WebServiceUtil;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.List;
import java.util.Optional;
import java.util.stream.Collectors;

@Service
public class SyncPatientDataByDeptCodeImpl implements SyncPatientDataByDeptCode {
    @Autowired
    OperatorDataMapper operatorDataMapper;
    @Autowired
    PatientDataMapper patientDataMapper;
    @Autowired
    DispatchInfoMapper dispatchInfoMapper;
    @Autowired
    DispatchDataMapper dispatchDataMapper;
    @Value("${hospital_id}")
    private Integer hospitalId;
    @Override
    public void saveCdm2() {

        LambdaQueryWrapper<PatientDataDO> patientDataDOLambdaQueryWrapper = new LambdaQueryWrapper<>();
        patientDataDOLambdaQueryWrapper.eq(PatientDataDO::getHospitalId,hospitalId);
        List<PatientDataDO> patientDataDOS1 = patientDataMapper.selectList(patientDataDOLambdaQueryWrapper);

        LambdaQueryWrapper<OperatorDataDO> operatorDataLambdaQueryWrapper = new LambdaQueryWrapper<>();
        operatorDataLambdaQueryWrapper.eq(OperatorDataDO::getHospitalId,hospitalId);
        operatorDataLambdaQueryWrapper.groupBy(OperatorDataDO::getDeptCode);
        List<OperatorDataDO> operatorDataDOS = operatorDataMapper.selectList(operatorDataLambdaQueryWrapper);
        List<String> collect = operatorDataDOS.stream().map(OperatorDataDO::getDeptCode).collect(Collectors.toList());
        for (String dept : collect) {
            List<PatientData> patientData = WebServiceUtil.getPatientDataByDeptCode(dept);
            if (CollUtil.isNotEmpty(patientData)) {
                List<Integer> deletedIds = new ArrayList<>();
                List<String> patientNos = new ArrayList<>();
                List<PatientDataDO> collect1 = patientDataDOS1.stream().filter(item -> item.getDeptCode().equals(dept)).collect(Collectors.toList());
                for (PatientDataDO patientDataDO : collect1) {
                    Optional<PatientData> first = patientData.stream().filter(item -> item.getPatientNo().equals(patientDataDO.getPatientNo())).findFirst();
                    if (!first.isPresent()) {
                        deletedIds.add(patientDataDO.getId());
                        patientNos.add(patientDataDO.getPatientNo());
                    }
                }
                if (CollUtil.isNotEmpty(deletedIds)) {
                    patientDataMapper.deleteBatchIds(deletedIds);
                    // 删除对应医嘱
                    deleteDispatch(patientNos);
                }
                List<PatientDataDO> patientDataDOS = BeanUtil.copyToList(patientData, PatientDataDO.class);
                operatorDataMapper.replacePatientData(patientDataDOS, hospitalId);
            }
        }
    }

    private void deleteDispatch(List<String> patientNos){
        if (CollUtil.isEmpty(patientNos)){
            return;
        }
        LambdaQueryWrapper<DispatchDataDO> dispatchDataDOLambdaQueryWrapper = new LambdaQueryWrapper<>();
        dispatchDataDOLambdaQueryWrapper.in(DispatchDataDO::getPatientNo,patientNos);
        List<DispatchDataDO> dispatchDataDOS = dispatchDataMapper.selectList(dispatchDataDOLambdaQueryWrapper);
        if (CollUtil.isNotEmpty(dispatchDataDOS)){
            List<Integer> collect2 = dispatchDataDOS.stream().map(DispatchDataDO::getId).collect(Collectors.toList());
            dispatchDataMapper.deleteBatchIds(collect2);
        }

        LambdaQueryWrapper<DispatchInfoDO> dispatchInfoDOLambdaQueryWrapper = new LambdaQueryWrapper<>();
        dispatchInfoDOLambdaQueryWrapper.in(DispatchInfoDO::getPatientCode,patientNos);
        List<DispatchInfoDO> dispatchInfoDOS = dispatchInfoMapper.selectList(dispatchInfoDOLambdaQueryWrapper);
        if (CollUtil.isNotEmpty(dispatchInfoDOS)){
            List<Integer> collect2 = dispatchInfoDOS.stream().map(DispatchInfoDO::getId).collect(Collectors.toList());
            dispatchInfoMapper.deleteBatchIds(collect2);
        }
    }
}
